
			.586
			.model flat,stdcall
			option casemap:none
			
			include windows.inc
			include kernel32.inc
			include user32.inc
			include gdi32.inc
			include \masm32\macros\macros.asm
			
			includelib kernel32.lib
			includelib user32.lib
			includelib gdi32.lib
			
			WinMain 	PROTO :DWORD,:DWORD,:DWORD,:DWORD
			WndProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD
			EraseBall 	PROTO :DWORD
			DrawBall 	PROTO :DWORD
			UpdateBall 	PROTO :DWORD
			
			.data?
			
			hInstance 	HINSTANCE 	?
			hBall 		HANDLE 		?
			hMask 		HANDLE 		?
			hBall2		HANDLE		?
			hMask2		HANDLE		?
			ballX		DWORD		?
			ballY		DWORD		?
			deltaX		DWORD		?
			deltaY		DWORD 		?
			ball2X		DWORD		?
			ball2Y		DWORD		?
			delta2X		DWORD		?
			delta2Y		DWORD		?
			bm2			BITMAP <>
			bm			BITMAP <>
			
			.data
			
			ClassName	db	"Window_Class",0
			DspName		db	"Animation",0
			
			.const
			
			TimerID		dd	100
			TDelay		dd	10
			deltaVal	dd	4
			delta2Val	dd  -4
			
			.code
			
			start:
			
				mov	hInstance,FUNC(GetModuleHandle,NULL)
				invoke WinMain,hInstance,NULL,NULL,SW_SHOWDEFAULT
				invoke ExitProcess,NULL
				
			WinMain PROC hInst:DWORD,hPrevInst:DWORD,hCmdLine:DWORD,nCmdShow:DWORD
			
				LOCAL wc:	WNDCLASSEX
				LOCAL hWin:	HANDLE
				LOCAL msg:	MSG
				
				mov wc.cbClsExtra,NULL
				mov wc.cbSize,sizeof WNDCLASSEX
				mov wc.cbWndExtra,NULL
				mov wc.hbrBackground,COLOR_WINDOW+1
				mov wc.hCursor,FUNC(LoadCursor,hInst,IDC_ARROW)
				mov wc.hIcon,FUNC(LoadIcon,hInst,500)
				mov wc.hIconSm,NULL
				m2m wc.hInstance,hInst
				mov wc.lpfnWndProc,OFFSET WndProc
				mov wc.lpszClassName,OFFSET ClassName
				mov wc.lpszMenuName,NULL
				mov wc.style,CS_HREDRAW or CS_VREDRAW
				
				invoke RegisterClassEx,ADDR wc
				invoke CreateWindowEx,0,ADDR ClassName,ADDR DspName,WS_OVERLAPPEDWINDOW,300,300,250,200,0,0,hInst,0
				mov hWin,eax
				invoke ShowWindow,hWin,nCmdShow
				invoke UpdateWindow,hWin
				.repeat
					invoke GetMessage,ADDR msg,hWin,0,0
					.break .if !eax
					invoke TranslateMessage,ADDR msg
					invoke DispatchMessage,ADDR msg
				.until FALSE
	
					mov eax,msg.wParam
				Ret
			WinMain EndP
			
			WndProc PROC hwnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
			
				LOCAL ps:		PAINTSTRUCT
				LOCAL hdcWin:	HDC
				LOCAL rc:		RECT
				
				switch uMsg 
				
					case WM_CLOSE
					
						invoke ExitProcess,0 
						
					case WM_PAINT 
						
						invoke BeginPaint,hwnd,ADDR ps
						mov hdcWin,eax
						invoke DrawBall,hdcWin
						invoke EndPaint,hwnd,ADDR ps
						
					case WM_CREATE
						
						invoke GetClientRect,hwnd,ADDR rc	
						invoke LoadBitmap,hInstance,600
						mov hBall,eax
						mov hBall2,eax
						invoke LoadBitmap,hInstance,700
						mov hMask,eax
						mov hMask2,eax
						invoke GetObject,hBall,sizeof BITMAP,ADDR bm
						invoke GetObject,hBall2,sizeof BITMAP,ADDR bm2
						invoke SetTimer,hwnd,TimerID,TDelay,NULL
						mov ballX,0
						mov ballY,0
						m2m deltaX,deltaVal
						m2m deltaY,deltaVal
						
						m2m ball2X,rc.right
						m2m ball2Y,rc.bottom
						m2m delta2X,delta2Val
						m2m delta2Y,delta2Val
						
					case WM_TIMER
						
						invoke GetDC,hwnd
						mov hdcWin,eax
						invoke EraseBall,hdcWin
						invoke UpdateBall,hwnd
						invoke DrawBall,hdcWin
						invoke ReleaseDC,hwnd,hdcWin
					
					case WM_DESTROY
					
						invoke KillTimer,hwnd,TimerID
						invoke DestroyWindow,hwnd
						invoke PostQuitMessage,0
						
					
				endsw
					invoke DefWindowProc,hwnd,uMsg,wParam,lParam
				Ret
			WndProc EndP
			
			EraseBall PROC hdc:HDC
			
				LOCAL rc:	RECT
				LOCAL rc2:	RECT
				
				m2m rc.top,ballY
				m2m rc.left,ballX
				mov eax,ballX
				add eax,bm.bmWidth
				mov rc.right,eax
				mov eax,ballY
				add eax,bm.bmHeight
				mov rc.bottom,eax 
				invoke FillRect,hdc,ADDR rc,COLOR_WINDOW+1
				
				m2m rc2.top,ball2Y
				m2m rc2.left,ball2X
				mov eax,ball2Y
				add eax,bm2.bmHeight
				mov rc2.bottom,eax
				mov eax,ball2X
				add eax,bm2.bmWidth
				mov rc2.right,eax
				
				
				invoke FillRect,hdc,ADDR rc2,COLOR_WINDOW+1
			
			Ret
			EraseBall EndP
			
			DrawBall  PROC hdc:HDC
			
				LOCAL hdcMem:	HDC
				
				invoke CreateCompatibleDC,hdc
				mov hdcMem,eax 
				invoke SelectObject,hdcMem,hMask
				invoke BitBlt,hdc,ballX,ballY,bm.bmWidth,bm.bmHeight,hdcMem,0,0,SRCAND
				invoke SelectObject,hdcMem,hBall
				invoke BitBlt,hdc,ballX,ballY,bm.bmWidth,bm.bmHeight,hdcMem,0,0,SRCPAINT
				invoke SelectObject,hdcMem,hMask2
				invoke BitBlt,hdc,ball2X,ball2Y,bm2.bmWidth,bm.bmHeight,hdcMem,0,0,SRCAND
				invoke SelectObject,hdcMem,hBall2
				invoke BitBlt,hdc,ball2X,ball2Y,bm2.bmWidth,bm2.bmHeight,hdcMem,0,0,SRCPAINT
				invoke DeleteDC,hdcMem
				
		
			
			Ret
			DrawBall EndP
			
			UpdateBall PROC hwnd:HANDLE
			
				LOCAL rc 	:RECT
				
				invoke GetClientRect,hwnd,ADDR rc
				
				mov eax,ballX
				add eax,deltaX
				mov ballX,eax
				mov eax,ballY
				add eax,deltaY
				mov ballY,eax
				
				mov eax,ball2X
				add eax,delta2X
				mov ball2X,eax
				mov eax,ball2Y
				add eax,delta2Y
				mov ball2Y,eax
				
				.if ballX > 65535
				
					mov ballX,0
					m2m deltaX,deltaVal
					
				.endif
				
				.if ballY > 65535
				
					mov ballY,0
					m2m deltaY,deltaVal
			
				.endif
				
				.if ball2X > 65535
				
					mov ball2X,0
					m2m delta2X,deltaVal
					
				.endif
				
				.if ball2Y > 65535
				
					mov ball2Y,0
					m2m delta2Y,deltaVal
					
				.endif
				
				mov eax,ballX
				add eax,bm.bmWidth
				.if eax > rc.right
				
					mov eax,rc.right
					sub eax,bm.bmWidth
					mov ballX,eax
					xor eax,eax
					sub eax,deltaVal
					mov deltaX,eax
				
				.endif
				
				mov eax,ballY
				add eax,bm.bmHeight
				.if eax > rc.bottom
					
					mov eax,rc.bottom
					sub eax,bm.bmHeight
					mov ballY,eax
					xor eax,eax
					sub eax,deltaVal
					mov deltaY,eax
					
				.endif
				
				mov eax,ball2X
				add eax,bm2.bmHeight
				.if eax > rc.right
					
					mov eax,rc.right
					sub eax,bm2.bmWidth
					mov ball2X,eax
					m2m delta2X,delta2Val
					
				.endif
				
				mov eax,ball2Y
				add eax,bm2.bmHeight
				.if eax > rc.bottom
				
					mov eax,rc.bottom
					sub eax,bm2.bmHeight
					mov ball2Y,eax
					m2m delta2Y,delta2Val
					
				.endif
			
			
			
			
			Ret
			UpdateBall EndP
			
			END start
			
			
			
			
			
			
			
			
			
			
			
			
			